#include <iostream>
#include <vector>
#include <utility>
#include <set>
#include <algorithm>
using namespace std;
int main(){
    int n;
    cin >> n;
    vector<pair<int, int>> arr;
    set<pair<int, int>> s;
    for(int i = 0; i < n; ++i) arr.push_back({0, i});
    for(int i = 0; i < n - 1; ++i){
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        --arr[u].first;
        --arr[v].first;
        s.insert({u, v});
        s.insert({v, u});
    }
    sort(arr.begin(), arr.end());
    int i = -1, j = -1;
    while(j == -1){
        ++i;
        for(int k = i + 1; k < n; ++k){
            auto x = arr[k];
            if (s.find({x.second, arr[i].second}) == s.cend()){
                j = x.second;
                break;
            }
        }
    }
    --arr[i].first;
    --arr[j].first;
    int64_t ans = 0;
    for(int i = 0; i < n; ++i) ans += arr[i].first * (arr[i].first + 1) / 2;
    cout << ans << endl << 1 + arr[i].second << " " << 1 + arr[j].second;
    return 0;
}
