#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define f first
#define s second
using namespace std;

const int N = 2e5+5;

int po = 1, st[2*N], soot[N], cnt[N];
vector <int> g[N];

int sum( int l, int r ) {
    int res = 0;

    l += po - 1;
    r += po - 1;

    while( l <= r ) {
        if( l % 2 ) {
            res += st[l++];
        }

        if( !(r % 2) ) {
            res += st[r--];
        }

        l/=2;
        r/=2;
    }

    return res;
}

void upd( int i, int x )
{
    i += po - 1;
    st[i] += x;
    for( i /= 2; i; i /= 2 )
    {
        st[i] = st[i * 2] + st[i * 2 + 1];
    }
}

int main() {
    ios_base::sync_with_stdio(0);

    int n, x, y, ansl, ansr, ma = 0, sumcnt = 0;

    cin >> n;

    for( int i = 1; i < n; i *= 2 ) {
        if( i * 2 >= n ) {
            po = i * 2;
        }
    }

    for( int i = 0; i < n - 1; i++ ) {
        cin >> x >> y;

        g[x].push_back( y );
        g[y].push_back( x );

        cnt[x]++;
        cnt[y]++;
    }

    vector <pair<int, int>> ar;

    for( int i = 1; i < N; i++ ) {
        if( cnt[i] ) {
            ar.push_back( {cnt[i], i} );
        }

        sumcnt += cnt[i] * (cnt[i] - 1) / 2;
    }

    sort( ar.begin(), ar.end() );

    for( int i = 0; i < ar.size(); i++ ) {
        soot[ar[i].second] = i+1;
    }

    for( int i = 1; i <= n; i++ ) {
        for( auto j : g[i] ) {
            upd( soot[j], 1 );
        }
        upd( soot[i], 1 );

        int l = 1, r = n;

        while( l <= r ) {
            int m = (l + r) / 2;

            int su = sum( m, r );

            if( su == r - m + 1 ) {
                r = m - 1;
            } else {
                l = m + 1;
            }
        }


        if( r && cnt[i] + ar[r-1].first > ma ) {
            ma = cnt[i] + ar[r-1].first;

            ansl = i;
            ansr = ar[r-1].second;
        }

        for( auto j : g[i] ) {
            upd( soot[j], -1 );
        }
        upd( soot[i], -1 );
    }

    cout << ma + sumcnt << '\n' << ansl << ' ' << ansr;

    return 0;
}
