#include <bits/stdc++.h>
#define x first
#define y second
#define deb if(debug)

using namespace std;

typedef long long ll;
typedef long double ld;
const bool debug = 0;

vector<vector<int>> graf;
vector<int> s;
vector<int> used;
int d0;

void dfs(int v,int d)
{
	if(s[v] == d || s[v] == d0)
		return;
	used[v] += (1<<d);
	for(int i=0;i<graf[v].size();i++)
		if(!((used[graf[v][i]] >> d) & 1))
			dfs(graf[v][i],d);
}

int main()
{
	if(!debug)
	{
		cin.tie(0);
		cout.tie(0);
		ios::sync_with_stdio(0);
	}
	int n,m,d;
	cin >> n >> m >> d;
	d0 = d;
	graf.resize(n);
	s.resize(n);
	used.resize(n);
	for(int i=0;i<n;i++)
	{
		cin >> s[i];
		s[i] --;
	}
	for(int i=0;i<m;i++)
	{
		int a,b;
		cin >>a >> b;
		a--;
		b--;
		graf[a].push_back(b);
		graf[b].push_back(a);
	}
	vector<vector<int>> out(d);
	vector<bool> p(n,0);
	for(int i=0;i<n;i++)
	{
		if(p[i] == 1)
			continue;
		out[s[i]].push_back(i+1);
		for(int j=0;j<n;j++)
			used[j] = 0;
		for(int j=0;j<d;j++)
			dfs(i,j);
		//cout << i << ':'  ;
		//for(int i=0;i<n;i++)
		//	cout << used[i] << ' ';
		//cout << '\n';
		for(int j =0;j<n;j++)
			if(i != j && used[j] == ((1<<d)-1 - (1<<s[i]) ))
			{
				p[j] = 1;
				s[j] = d;
			}
				
		p[i] = 1;
				s[i] = d;
		
	}
	for(int i=0;i<d;i++)
	{
		cout << out[i].size() << ' ';
		for(int j=0;j<out[i].size();j++)
			cout << out[i][j] << ' ';
		cout << '\n';
	}
    return 0;
    
}
