#include <bits/stdc++.h>

#define ins insert
#define ers erase
#define cls clear

#define ll long long
#define fi first
#define se second
#define dou long double

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define eb emplace_back
#define si size()
#define allv(v) v.begin(), v.end()
#define res resize
#define bk back()

#define deb if (debug)
#define cth deb cout << "H\n";
#define ct(i) deb cout << i << '\n';
#define ctv(v) deb{ for(auto i: v) cout << i << " "; cout << '\n';}
#define ctvp(v) deb{ for(auto i: v) cout << "{" << i.fi << ", " << i.se << "} "; cout << '\n';}
#define ctvv(v) deb{ for(ll i = 0; i < v.si; ++i){cout << i << ": "; for(auto j: v[i]) cout << j << " "; cout << '\n';}}

using namespace std;

bool debug = 0;

int main(){
	if(!debug) ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	ll n;
	cin >> n;
	vector <vector <ll>> v1(n, vector <ll> (n)), v2(n, vector <ll> (n));
	for(ll i = 0; i < n; ++i)
		for(ll j = 0; j < n; ++j)
			cin >> v1[i][j];
	for(ll i = 0; i < n; ++i)
		for(ll j = 0; j < n; ++j)
			cin >> v2[i][j];

	vector <deque <ll>> c1(n/2), c2(n/2);
	for(ll i = 0; i < n/2; ++i){
		for(ll j = i; j < n-i-1; ++j)
			c1[i].pb(v1[i][j]);
		for(ll j = i; j < n-i-1; ++j)
			c1[i].pb(v1[j][n-i-1]);
		for(ll j = n-i-1; j >= i+1; --j)
			c1[i].pb(v1[n-i-1][j]);
		for(ll j = n-i-1; j >= i+1; --j)
			c1[i].pb(v1[j][i]);
	}

	for(ll i = 0; i < n/2; ++i){
		for(ll j = i; j < n-i-1; ++j)
			c2[i].pb(v2[i][j]);
		for(ll j = i; j < n-i-1; ++j)
			c2[i].pb(v2[j][n-i-1]);
		for(ll j = n-i-1; j >= i+1; --j)
			c2[i].pb(v2[n-i-1][j]);
		for(ll j = n-i-1; j >= i+1; --j)
			c2[i].pb(v2[j][i]);
	}

	ctvv(c1)
	ctvv(c2)

	bool ok = 1;
	for(int i = 0; i < n/2 && ok; ++i){
		ok = 0;
		for(int j = 0; j < c1[i].si; ++j){
			if(c1[i] == c2[i]){
				ok = 1;
				break;
			}
			ll now = c2[i][0];
			c2[i].ppf();
			c2[i].pb(now);
		}
	}

	if(ok)
		cout << "YES";
	else
		cout << "NO";

	return 0;
}
/*
4
1 2 3 4
3 1 2 5
2 4 3 6
1 9 8 7
7 8 9 1
6 4 1 2
5 3 2 3
4 3 2 1

4
1 2 3 4
3 1 2 5
2 4 3 6
1 9 8 7
7 8 9 1
6 1 3 2
5 4 2 3
4 3 2 1
*/
