#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <sstream>
#include <set>

using namespace std;

typedef long long ll;

bool cmp(pair<int, int>a, pair<int, int>b){
    return a.first > b.first;
}

void solve(){
    int n;
    cin >> n;
    vector<pair<ll, int> >st(n);
    vector<ll>r(n);
    map<pair<ll, ll>, ll>w;
    for(int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        w[{a - 1, b - 1}]++;
        w[{b - 1, a - 1}]++;
        st[a - 1].first++;
        st[b - 1].first++;
        st[i].second = i;
    }
    st[n - 1].second = n - 1;
    ll sum1 = 0;
    for(int i = 0; i < n; i++){
        r[i] = (st[i].first * (st[i].first - 1)) / 2;
        sum1 += r[i];
    }
    sort(st.begin(), st.end(), cmp);
    if(st[0].first == n - 1){
        r[st[1].second] = (st[1].first * (st[1].first + 1)) / 2;
        r[st[2].second] = (st[2].first * (st[2].first + 1)) / 2;
        ll sum = 0;
        for(int i = 0; i < n; i++){
            sum += r[i];
        }
        cout << sum << endl;
        cout << st[1].second + 1 << ' ' << st[2].second + 1 << endl;
        return;
    }
    ll a = -1, b = -1;
    for(int i = 1; i < n; i++){
        if(!w[{st[0].second, st[i].second}]){
            r[st[0].second] = ((st[0].first + 1) * st[0].first) / 2;
            r[st[i].second] = ((st[i].first + 1) * st[i].first) / 2;
            a = st[0].second, b = st[i].second;
            break;
        }
    }
    ll sum = 0;
    for(int i = 0; i < n; i++){
        sum += r[i];
    }
    cout << sum << endl;
    cout << a + 1 << ' ' << b + 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
    return 0;
}
