#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <sstream>
#include <set>

using namespace std;

typedef long long ll;

vector<vector<int> >g;
vector<int>c;
vector<bool>used;

void dfs(int v, int enemy){
    used[v] = 1;
    for(int i = 0; i < g[v].size(); i++){
        if(c[g[v][i]] != enemy && !used[g[v][i]]){
            dfs(g[v][i], enemy);
        }
    }
}

void solve(){
    int n, m, d;
    cin >> n >> m >> d;
    g.resize(n); c.resize(n); used.resize(n);
    vector<vector<int> >emp(d);
    for(int i = 0; i < n; i++){
        cin >> c[i];
        c[i]--;
        emp[c[i]].push_back(i);
    }
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<vector<int> >s(d);
    int mn = 1e9;
    for(int i = 0; i < d; i++){
        vector<int>ans;
        int mx = 0;
        for(int j = 0; j < d; j++){
            if(i == j)
                continue;
            vector<int>to;
            for(int k = 0; k < emp[i].size(); k++){
                if(!used[emp[i][k]]){
                    dfs(emp[i][k], j);
                    to.push_back(emp[i][k]);
                }
            }
            if(mx < to.size()){
                mx = to.size();
                ans = to;
            }
            used.assign(n, 0);
        }
        s[i] = ans;
    }
    for(int i = 0; i < d; i++){
        cout << s[i].size() << ' ';
        for(int j = 0; j < s[i].size(); j++){
            cout << s[i][j] + 1 << ' ';
        }
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
    return 0;
}
