#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi =  vector<pi>;

template <class T> bool ckmin(T &a,T b) { return a > b ? a = b, true : false; }
template <class T> bool ckmax(T &a,T b) { return a < b ? a = b, true : false; }

const int INF = 1e9+7;
const ll LINF = 1e18;

const int N = 3e4+228, D=20;

vector<vi> g;
int used[N], ucn, col[D+1][N], ncol;

void dfs(int v, int rej, vi& e) {
    if(e[v] == rej || used[v] == ucn) return;
    used[v] = ucn;
    col[rej+1][v] = ncol;
    for(int to : g[v]) dfs(to, rej, e);
}

bool cmp(int l, int r) {
    for(int i = 0; i <= D; ++i) {
        if(col[i][l] < col[i][r]) return true;
        if(col[i][l] > col[i][r]) return false;
    }
    return false;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, m, d; cin >> n >> m >> d;
    vi cnt(d);
    vi e(n); for(int& x : e) cin >> x, cnt[--x]++;
    g.resize(n);
    for(int i = 0; i < m; ++i) {
        int a, b; cin >> a >> b;
        g[a-1].pb(b-1), g[b-1].pb(a-1);
    }
    for(int i = 0; i < d; ++i) {
        ++ucn;
        for(int v = 0; v < n; ++v) {
            if(used[v] != ucn) ++ncol, dfs(v, i, e);
        }
    }

    for(int i = 0; i < d; ++i) {
        vi ids;
        for(int j = 0; j < n; ++j) if(e[j] == i) ids.pb(j);
        sort(all(ids), cmp);
        vi ans;
        for(int i = 0; i < ids.size(); ++i) {
            if(!i || cmp(ids[i-1], ids[i])) ans.pb(ids[i]);
        }

        cout << ans.size();
        for(int i : ans) cout << ' ' << i+1;
        cout << endl;
    }
}
