#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi =  vector<pi>;

template <class T> bool ckmin(T &a,T b) { return a > b ? a = b, true : false; }
template <class T> bool ckmax(T &a,T b) { return a < b ? a = b, true : false; }

const int INF = 1e9+7;
const ll LINF = 1e18;

vector <int> f;
int d;
void add(int k,int c){
    for(;k<=d;k+=k&-k) f[k] += c;
}

int sum(int k){
    int res = 0;
    for(;k>0;k-=k&-k) res += f[k];
    return res;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin>>n;
    vector <pair<int,int>> v(n);
    d = 2*n;
    f.resize(d+1);

    vi values;
    for(int i=1;i<=d;i++) add(i,1);
    for(int i=0;i<n;i++){
        cin>>v[i].F; values.pb(v[i].F);
        v[i].S = i+1;
    }

    sort(all(values));
    vector<set<int>> positions(n);
    for(int i = 0; i < n; ++i) {
        positions[lower_bound(values.begin(), values.end(), v[i].F) - values.begin()].insert(v[i].S);
    }

    sort(all(v),[](pair<int,int> &a,pair<int,int> &b){
        return tie(a.F,b.S) < tie(b.F,a.S);
    });
    ll ans = 0;
    for(int i=0,cur = 1;i<n;i++){
        int val = values[n-i-1];
        int sid = lower_bound(values.begin(), values.end(), val) - values.begin();
        auto it = positions[sid].lower_bound(cur);
        if(it == positions[sid].end()) it = positions[sid].begin();

        int pos = *it;
        positions[sid].erase(it);

        //cout << sid << " " << pos << endl;

        if(cur <= pos) ans += sum(pos-1) - sum(cur-1);
        else ans += sum(pos+n-1) - sum(cur-1);
        add(pos,-1), add(pos+n,-1);
        cur = pos;
    }
    cout<<ans<<endl;
}
