#include <bits/stdc++.h>
#define len(s) (int)s.size();
using namespace std;
#define  PB push_back
using ll = long long;
using ld = long double;

vector<int> g(200010);
set<pair<int, int>> edges;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        g[a]++;
        g[b]++;
        edges.insert(make_pair(min(a, b), max(a, b)));
    }
    auto v = vector<int>(n + 1);
    for (int i = 1; i <= n; i++) v[i] = i;
    sort(v.begin() + 1, v.end(), [](int l, int r) {return g[l] > g[r];
    });

    int ansRazv = 0;
    int aF = 0;
    int aS = 0;
    for (int f = 1; f <= n; f++) {
        for (int s = f + 1; s <= min(n, f + 1000); s++) {
            if (
                    g[v[f]] + g[v[s]] > ansRazv &&
                    edges.count(make_pair(min(v[f], v[s]), max(v[f], v[s]))) == 0) {
                ansRazv = g[v[f]] + g[v[s]];
                aF = v[f];
                aS = v[s];
            }
        }
    }

    int totalRazvBefore = 0;
    for (int i = 1; i <= n; i++) totalRazvBefore += g[i] * (g[i] - 1) / 2;

    cout << totalRazvBefore + ansRazv << '\n' << aF << ' ' << aS << '\n';
    return 0;
}
/*
4
 1 2
 2 3
 3 4

6
1 2
1 3
 1 4
4 5
4 6
 */