#include <bits/stdc++.h>
#define len(s) (int)s.size();
using namespace std;
using ll = long long;
using ld = long double;

const int max_size = 30000 + 5;
vector<int> g[max_size];
vector<int> imperia[22];
int code [max_size];
int n, m, d;

void dfs(int v, int enemy, vector<bool>&used){
    used[v] = true;
    for(int i : g[v]){
        if(!used[i] && code[i] != enemy) dfs(i, enemy, used);
    }
}

void count(int v){
    int cnt = 0;
    vector<bool>shtab(max_size, false);
    
    for(int enemy = 1; enemy <= d; enemy++){
        if(enemy == v) continue;
        
        vector<bool>used(max_size, false);
        for(int i : imperia[v]){
            if(!used[i]) {
                dfs(i, enemy, used);
                if(!shtab[i]){
                    cnt++;
                    shtab[i] = true;
                }
            }
        }
    }
    cout << cnt << ' ';
    for(int i = 1; i <= n; i++){
        if(shtab[i]) cout << i << ' ';
    }
    cout << '\n';
}

int main(){
    //what happened?
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> d;
    for(int i = 1; i <= n; i++) {
        cin >> code[i];
        imperia[code[i]].emplace_back(i);
    }
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    for(int i = 1; i <= d; i++){
        count(i);
    }
    return 0;
}