#include <bits/stdc++.h>
#define len(s) (int)s.size();
using namespace std;
using ll = long long;
using ld = long double;

struct MatrixOf2 {
    int a, b;
};

struct MatrixOf4 {
    int a, b, c, d;
};

MatrixOf2 operator*(MatrixOf4 a, MatrixOf2 b) {
    return MatrixOf2{a.a * b.a + a.b * b.b, a.c * b.a + a.d * b.b};
}

MatrixOf4 operator*(MatrixOf4 a, MatrixOf4 b) {
    return MatrixOf4{
        a.a * b.a + a.b * b.c,
            a.a * b.b + a.b * b.d,
            a.c * b.a + a.d * b.c,
                a.c * b.b + a.d * b.d
        };
}

MatrixOf4 operator%(MatrixOf4 a, int mod) {
    return MatrixOf4{a.a % mod, a.b %mod, a.c % mod, a.d % mod};
}

MatrixOf4 fastPow(MatrixOf4 k, int n, int mod) {
    if (n == 1) return k;
    if (n == 0) return MatrixOf4{0, 1, 1, 0};
    if (n % 2 == 0) return fastPow((k * k) % mod, n / 2, mod);
    if (n % 2 == 1) return (fastPow(k, n - 1, mod) * k) % mod;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    if (n == 0) {
        cout << 0;
        return 0;
    }

    MatrixOf4 magic = MatrixOf4{0, 1,1,1};
    auto f1 = MatrixOf2{0, 1};
    auto p = fastPow(magic, n, 3);
    //auto p = magic * magic;
    auto fi = p * f1;
    //cerr << p.a << ' ' << p.b << ' ' << p.c << ' ' << p.d << '\n';
    //cerr << fi.a << ' ' << fi.b << '\n';
    cout << fi.a % 3;
    return 0;
}