from collections import deque


n = int(input())
frames1 = [None] * (n // 2)
frames2 = [None] * (n // 2)
for i in range(n):
    line = deque(map(int, input().split()))
    if i < n // 2:
        for j in range(i + 1):
            if j == i:
                frames1[j] = line
            else:
                frames1[j].append(line.pop())
                frames1[j].appendleft(line.popleft())
    else:
        for j in range(n - i):
            if j == n - i - 1:
                line.reverse()
                frames1[j].extend(line)
            else:
                frames1[j].append(line.pop())
                frames1[j].appendleft(line.popleft())

for i in range(n):
    line = deque(map(int, input().split()))
    if i < n // 2:
        for j in range(i + 1):
            if j == i:
                frames2[j] = line
            else:
                frames2[j].append(line.pop())
                frames2[j].appendleft(line.popleft())
    else:
        for j in range(n - i):
            if j == n - i - 1:
                line.reverse()
                frames2[j].extend(line)
            else:
                frames2[j].append(line.pop())
                frames2[j].appendleft(line.popleft())

minecraft_story_mode = []
for i in range(n // 2):
    line = frames1[i]
    for _ in range(len(line)):
        if line == frames2[i]:
            minecraft_story_mode.append(True)
            break
        else:
            last_elem = line.pop()
            line.appendleft(last_elem)
    else:
        minecraft_story_mode.append(False)
if all(minecraft_story_mode):
    print('YES')
else:
    print('NO')
