#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define f first
#define s second
using namespace std;

struct node {
    int next[2], leaf;
    ll sum;
} r;

vector <node> t;

int sz = 1;

void add(int x) {
    ll v = 0, y = x;
    while (x) {
        if (!t[v].next[x%2])
            t[v].next[x%2] = sz++,
            t.push_back(r);
        v = t[v].next[x%2];
        t[v].sum += y;
        t[v].leaf++;
        x >>= 1;
    }
}

void one(int vz, int vo) {
    t[vz].sum += t[vo].sum - t[vo].leaf;
    t[vz].leaf += t[vo].leaf;
    if (t[vo].next[0]) {
        if (!t[vz].next[0])
            t[vz].next[0] = sz++,
            t.push_back(r);
        one(t[vz].next[0], t[vo].next[0]);
    }
    if (t[vo].next[1]) {
        if (!t[vz].next[1])
            t[vz].next[1] = sz++,
            t.push_back(r);
        one(t[vz].next[1], t[vo].next[1]);
    }
}

void split(int v, int u) {
    t[v].sum += t[u].sum >> 1;
    t[v].leaf += t[u].leaf;
    if (t[u].next[0]) {
        if (!t[v].next[0])
            t[v].next[0] = sz++,
            t.push_back(r);
        split(t[v].next[0], t[u].next[0]);
    }
    if (t[u].next[1]) {
        if (!t[v].next[1])
            t[v].next[1] = sz++,
            t.push_back(r);
        split(t[v].next[1], t[u].next[1]);
    }
}

void upd(int v) {
    t[v].sum >>= 1;
    if (t[v].next[0])
        upd(t[v].next[0]);
    if (t[v].next[1])
        upd(t[v].next[1]);
}

int main() {
    //freopen("input.txt", "r", stdin);

    t.push_back(r);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        add(x);
    }
    char x;
    while (cin >> x) {
        if (x - 48) {
            if (t[0].next[1]) {
                if (!t[0].next[0])
                    t[0].next[0] = sz++,
                    t.push_back(r);
                one(t[0].next[0], t[0].next[1]);
                t[0].next[1] = 0;
            }
        }
        else {
            if (t[0].next[0])
                if (t[t[0].next[0]].next[1]) {
                    if (!t[0].next[1])
                        t[0].next[1] = sz++,
                        t.push_back(r);
                    split(t[0].next[1], t[t[0].next[0]].next[1]);
                }
            t[0].next[0] = t[t[0].next[0]].next[0];
            if (t[0].next[0])
                upd(t[0].next[0]);
        }
        cout << t[t[0].next[0]].sum + t[t[0].next[1]].sum << endl;
    }

    return 0;
}
