#include <bits/stdc++.h>
#define x first
#define y second
#define deb if(debug)

using namespace std;

typedef long long ll;
typedef long double ld;
const bool debug = 0;


vector<pair<int,int>> p;
vector<vector<int>> graf;
vector<int> s;

int get(int v)
{
	if(p[v].x == -1)
		return v;
	p[v].x = get(p[v].x);
	return p[v].x;
}

void merg(int a,int b)
{
	a = get(a);
	b = get(b);
	if(p[a].y < p[b].y)
		swap(a,b);
	if(a!=b)
	{
		p[b].x = a;
	}
}

int main()
{
	if(!debug)
	{
		cin.tie(0);
		cout.tie(0);
		ios::sync_with_stdio(0);
	}
	int n,m,d;
	cin >> n >> m >> d;
	graf.resize(n);
	s.resize(n);
	p.resize(n,{-1,1});
	for(int i=0;i<n;i++)
		cin >> s[i];
	for(int i=0;i<n;i++)
		s[i] --;
	for(int i=0;i<m;i++)
	{
		int a,b;
		cin >>a >> b;
		a--;
		b--;
		graf[a].push_back(b);
		graf[b].push_back(a);
	}
	for(int v=0;v<n;v++)
		for(int i=0;i<graf[v].size();i++)
			if(s[graf[v][i]] == s[v])
				merg(v,graf[v][i]);
	vector<vector<int>> out(d);
	for(int i=0;i<n;i++)
		if(p[i].x == -1)
			out[s[i]].push_back(i+1);
	for(int i=0;i<d;i++)
	{
		cout << out[i].size() << ' ';
		for(int j=0;j<out[i].size();j++)
			cout << out[i][j] << ' ';
		cout << '\n';
	}
    return 0;
}
