#include <bits/stdc++.h>
#define x first
#define y second
#define deb if(debug)

using namespace std;

typedef long long ll;
typedef long double ld;
const bool debug = 0;

struct fmat
{
	int a[2][2];
	fmat()
	{
		for(int i=0;i<2;i++)
			for(int j=0;j<2;j++)
				a[i][j] = 0;
	}
};

fmat operator *(const fmat &a,const fmat &b)
{
	fmat out;
	for(int i=0;i<2;i++)
		for(int j=0;j<2;j++)
		{
			for(int k=0;k<2;k++)
				out.a[i][j] += a.a[i][k] * b.a[k][j];
			out.a[i][j] %= 3;
		}
	return out;
}

fmat st(fmat a,int b)
{
	if(b == 1)
		return a;
	if(b%2 == 0)
	{
		fmat d = st(a,b/2);
		return d*d;
	}
	else
		return st(a,b-1)*a;
}


int main()
{
	if(!debug)
	{
		cin.tie(0);
		cout.tie(0);
		ios::sync_with_stdio(0);
	}
   	int n;
   	cin >> n;
   	fmat d;
   	d.a[0][0] = 0;
   	d.a[0][1] = 1;
   	d.a[1][0] = 1;
   	d.a[1][1] = 1;
   	if(n == 0)
	{
		cout << 0;
	}
	else
	{
		d = st(d,n);
		cout << d.a[0][1];
	}
    return 0;
}
