#include <bits/stdc++.h>

#define ins insert
#define ers erase
#define cls clear

#define ll long long
#define fi first
#define se second
#define dou long double

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define eb emplace_back
#define si size()
#define allv(v) v.begin(), v.end()
#define res resize
#define bk back()

#define deb if (debug)
#define cth deb cout << "H\n";
#define ct(i) deb cout << i << '\n';
#define ctv(v) deb{ for(auto i: v) cout << i << " "; cout << '\n';}
#define ctvp(v) deb{ for(auto i: v) cout << "{" << i.fi << ", " << i.se << "} "; cout << '\n';}
#define ctvv(v) deb{ for(ll i = 0; i < v.si; ++i){cout << i << ": "; for(auto j: v[i]) cout << j << " "; cout << '\n';}}

using namespace std;

bool debug = 0;

ll n;
vector <ll> v, tr;
vector <pair <ll, ll>> srt;

void add(int p, int L, int R, int ind, ll val){
	if(ind < L || ind >= R)
		return;
	if(L+1==R){
		tr[p] = val;
		return;
	}
	int M = (L+R)>>1;
	add(p+p+1, L, M, ind, val);
	add(p+p+2, M, R, ind, val);
	tr[p] = max(tr[p+p+1], tr[p+p+2]);
}

ll get(int p, int L, int R, int a, int b){
	if(a == b)
		return -1;
	if(L >= b || R <= a)
		return -1;
	if(a <= L && R <= b)
		return tr[p];

	int M = (L+R)>>1;
	ll g1 = get(p+p+1, L, M, a, b), g2 = get(p+p+2, M, R, a, b);
	return max(g1, g2);
}

int main(){
	if(!debug) ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	cin >> n;
	v.res(n);
	srt.res(n);
	for(int i = 0; i < n; ++i){
		cin >> v[i];
		srt[i] = {v[i], i};
	}

	tr.res(4*n, -1);
	ll ans = 0;
	sort(allv(srt));
	reverse(allv(srt));
	for(int i = 0; i < n; ++i){
		vector <pair <ll, ll>> now;
		now.pb(srt[i]);
		while(i < n-1 && srt[i+1].fi == srt[i].fi){
			now.pb(srt[i+1]);
			++i;
		}
		vector <pair <ll, ll>> nw;
		for(int j = 0; j < now.si; ++j){
			deb cout << now[j].fi << " " << now[j].se << " " << get(0, 0, n, 0, now[j].se) << " " << get(0, 0, n, now[j].se+1, n) << '\n';
			ll ansn = max(0LL, max(get(0, 0, n, 0, now[j].se), get(0, 0, n, now[j].se+1, n) + 1));
			nw.pb({now[j].se, ansn});
			ans += ansn;
		}
		for(int j = 0; j < nw.si; ++j)
			add(0, 0, n, nw[j].fi, nw[j].se);
	}

	cout << ans;


	return 0;
}