#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <sstream>
#include <set>

using namespace std;

typedef long long ll;

void solve(){
    int n;
    cin >> n;
    vector<vector<int> >a(n, vector<int>(n));
    vector<vector<int> >b(n, vector<int>(n));
    vector<vector<int> >x(n / 2), y(n / 2);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> a[i][j];
        }
    }
    for(int i = 0; i < n / 2; i++){
        for(int j = i; j <= n - i - 2; j++){
            x[i].push_back(a[i][j]);
        }
        for(int j = i; j <= n - i - 1; j++){
            x[i].push_back(a[j][n - 1 - i]);
        }
        for(int j = n - i - 2; j >= i; j--){
            x[i].push_back(a[n - 1 - i][j]);
        }
        for(int j = n - i - 2; j >= i + 1; j--){
            x[i].push_back(a[j][i]);
        }
    }
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> b[i][j];
        }
    }
    for(int i = 0; i < n / 2; i++){
        for(int j = i; j <= n - i - 2; j++){
            y[i].push_back(b[i][j]);
        }
        for(int j = i; j <= n - i - 1; j++){
            y[i].push_back(b[j][n - 1 - i]);
        }
        for(int j = n - i - 2; j >= i; j--){
            y[i].push_back(b[n - 1 - i][j]);
        }
        for(int j = n - i - 2; j >= i + 1; j--){
            y[i].push_back(b[j][i]);
        }
    }
    for(int i = 0; i < n / 2; i++){
        bool ok = 0;
        for(int j = 0; j < x[i].size(); j++){
            bool f = 1;
            int c = x[i].size() - j - 1;
            for(int k = 0; k <= j; k++){
                if(x[i][k] != y[i][c]){
                    f = 0;
                    break;
                }
                c++;
            }
            c = 0;
            for(int k = j + 1; k < x[i].size(); k++){
                if(x[i][k] != y[i][c]){
                    f = 0;
                    break;
                }
                c++;
            }
            if(f){
                ok = 1;
                break;
            }
        }
        if(!ok){
            cout << "NO";
            return;
        }
    }
    cout << "YES";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
    return 0;
}
