#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <sstream>
#include <set>

using namespace std;

typedef long long ll;

ll c;

bool cmp(int a, int b){
    return (abs(a - c) < abs(b - c));
}

void solve(){
    int n;
    cin >> n;
    vector<ll>a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    ll b;
    cin >> b >> c;
    sort(a.begin(), a.end(), cmp);
    int l = 0, r = n + 1;
    while(r - l > 1){
        bool f = 1;
        int m = (l + r) / 2;
        vector<int>x;
        for(int i = 0; i < m; i++){
            x.push_back(a[i]);
        }
        if(b < c){
            sort(x.begin(), x.end());
        }
        else{
            sort(x.rbegin(), x.rend());
        }
        int carry = 0;
        for(int i = 0; i < m; i++){
            if(abs(x[i] - c) + carry < abs(b - c)){
                carry += abs(x[i] - c);
            }
            else{
                f = 0;
            }
        }
        if(!f){
            r = m;
        }
        else{
            l = m;
        }
    }
    cout << l;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while(t--){
        solve();
    }
    return 0;
}
