#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cctype>
#include <iomanip>
#include <climits>
using ll = long long;
using namespace std;
const int N = 300;
vector<vector<int>> a(N, vector<int> (N)), b(N, vector<int> (N));
vector <int> f, s;
void read(int n, vector<vector<int>> &v)
{
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) cin >> v[i][j];
    }
}
void make_mas(int cnt, int n, vector <int> &lin, vector<vector<int>> sqr)
{
    //lin.resize(4 * (n - 2 * cnt) - 4);
    for(int i = cnt; i < n - cnt; i++){
        lin.push_back(sqr[cnt][i]);
    }
    for(int i = cnt + 1; i < n - cnt - 1; i++){
        lin.push_back(sqr[i][n-cnt-1]);
    }
    for(int i = n - cnt - 1; i >= cnt + 1; i--){
        lin.push_back(sqr[n - cnt - 1][i]);
    }
    for(int i = n - cnt - 1; i >= cnt + 1; i--){
        lin.push_back(sqr[i][cnt]);
    }

    //for(auto i : lin){
    //    cout<<i<<" ";
    //}
}
bool change(vector <int> v_1, vector <int> v_2)
{
    int sz = v_1.size();
    for (int k = 0; k < sz; k++) {
            bool can = true;
        for (int i = 0; i < sz; i++) {
            if (v_1[i] != v_2[(i + k) % sz]) {
                can = false;
                break;
            }
        }
        if (can) return true;
    }
    return false;
}
int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    read(n, a);
    read(n, b);
    for (int cnt = 0; cnt < n / 2; cnt++) {
        make_mas(cnt, n, f, a);
        make_mas(cnt, n, s, b);
        if(!change(f, s) && !change(s, f)){
            cout<<"NO"; return 0;
        }
        f.clear();
        s.clear();
    }
    cout<<"YES";
    return 0;
}
