#include <bits/stdc++.h>
#define len(s) (int)s.size();
using namespace std;
using ll = long long;
using ld = long double;

struct Frame {
    vector<int> f;

    void rot1() {
        int l = f[0];
        for (int i = 0; i < f.size() - 1; i++) f[i] = f[i + 1];
        f[f.size() - 1] = l;
    }

    bool operator==(Frame &other) const {
        return f == other.f;
    }
};

int z[202][202];
const int moves[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
Frame oldLock[110];
Frame newLock[110];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    // GET FIRST LOCK
    for (int y = 1; y <= n; y++) {
        for (int x = 1; x <= n; x++) {
            cin >> z[y][x];
        }
    }

    for (int l = 1; l <= n / 2; l++) {
        int changes = 0;
        int m = 0;
        int x = l, y = l;
        while (changes < 4) {
            oldLock[l].f.push_back(z[y][x]);
            z[y][x] = 0;
            while (changes < 4 && z[y + moves[m][1]][x + moves[m][0]] == 0) {
                m = (m + 1) % 4;
                changes++;
            }
            if (changes >= 4) break;
            y += moves[m][1];
            x += moves[m][0];
        }
        //for (auto el: oldLock[l].f) cerr << el << ' ';
        //cerr << '\n';
    }
    //cerr << '\n';
    // GET SECOND LOCK
    for (int y = 1; y <= n; y++) {
        for (int x = 1; x <= n; x++) {
            cin >> z[y][x];
        }
    }
    for (int l = 1; l <= n / 2; l++) {
        int changes = 0;
        int m = 0;
        int x = l, y = l;
        while (changes < 4) {
            newLock[l].f.push_back(z[y][x]);
            z[y][x] = 0;
            while (changes < 4 && z[y + moves[m][1]][x + moves[m][0]] == 0) {
                m = (m + 1) % 4;
                changes++;
            }
            if (changes >= 4) break;
            y += moves[m][1];
            x += moves[m][0];
        }

        //for (auto el: newLock[l].f) cerr << el << ' ';
        //cerr << '\n';
    }
    // SPIN THE SPINNERS
    for (int l = 1; l <= n / 2; l++) {
        int rotsDone = 0;
        while (rotsDone < oldLock[l].f.size() && oldLock[l].f != newLock[l].f) {
            oldLock[l].rot1();
            rotsDone++;
        }
        if (rotsDone >= oldLock[l].f.size()) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES";


    return 0;
}